// NoPro - webwork 2007-2013

/*
 * some handy jquery-functions
 */

// 2013-02-05 bugfix: use outerWidth(true) instead of width()


// global vars
CRLF = "\r\n";
JQV = $().jquery;

/* for all jqc-functions jqobjects must have absolute positions */

/* jqo and jq2 have same parentNode or jq2 is $(window) */
function nopro_jqchoff(jqo, jq2) { return ((jq2.offset()) ? jq2.offset().left : 0) + parseInt((jq2.outerWidth(true) - jqo.outerWidth(true)) / 2); }
function nopro_jqcvoff(jqo, jq2) { return ((jq2.offset()) ? jq2.offset().top : 0) + parseInt((jq2.outerHeight(true) - jqo.outerHeight(true)) / 2); }
function nopro_jqch(jqo, jq2) { jqo.css('left', nopro_jqchoff(jqo, jq2) +'px'); }
function nopro_jqcv(jqo, jq2) { jqo.css('top', nopro_jqcvoff(jqo, jq2) +'px'); }

/* center jqo inside parent */
function nopro_jqc2phoff(jqo) { return parseInt((jqo.parent().outerWidth(true) - jqo.outerWidth(true)) / 2); }
function nopro_jqc2pvoff(jqo) { return parseInt((jqo.parent().outerHeight(true) - jqo.outerHeight(true)) / 2); }
function nopro_jqc2ph(jqo) { jqo.css('left', nopro_jqc2phoff(jqo) +'px'); }
function nopro_jqc2pv(jqo) { jqo.css('top', nopro_jqc2pvoff(jqo) +'px'); }

////////////////

function get_urlreq(url) {
    var robj = {};
    var req = url.split('?');
    if(req.length > 1) { $.each(req[1].split('&'), function(k, v) { q=v.split('='); robj[q[0]]=q[1]; }); }
    return robj;
}

function get_cookies(cs) {
    var robj = {};
    $.each(cs.split(';'), function(k, v) { q=v.split('='); robj[q[0].trim()]=q[1]; });
    return robj;
}

function emptybutts() {
    $.each($('input[type="checkbox"]'), function(k,v) {
        if(!v.disabled && !v.checked)  {
	    $(v.form).append('<input type="hidden" name="'+v.name+'" value="off"/>');
	}
    });
    //return false;	// prevent submission
    return true;
}

var jqo_a = null;
function jq_resize(eve, dst) {
    // all vars should be defined in nopro.js
    if(eve == null) { return false; }
    var dot = eve.target;	//  corner of obj to resize
    plane = dot.parentNode;
    jqo_a = dst ? $(dst) : $(plane);

    x0 = eve.clientX;
    y0 = eve.clientY;
    ow1 = $(plane).width();
    oh1 = $(plane).height();
    
    document.onmouseup = usr_done;
    document.onmousemove = jq_resizeit;

    return true;	// continue event-handler-chain
}

function jq_resizeit(eve) {
    if(plane && jqo_a) {
	var dw = eve.clientX - x0;
	var dh = eve.clientY - y0;
	jqo_a.width(ow1 + dw);
	jqo_a.height(oh1 + dh);
    }
    return false;	// end event-handler-chain
}

//////////////// enable dragging around of objects ////////////////
var npjq_2drag = null;
function npjq_drag(obj, eve) {
    if(!npjq_2drag || npjq_2drag.box != obj) return true;
    var x = npjq_2drag.x0 - (npjq_2drag.evex0 - eve.clientX);
    var y = npjq_2drag.y0 - (npjq_2drag.evey0 - eve.clientY);
    if(npjq_2drag.lim && npjq_2drag.lim.x0) {
	var x1 = npjq_2drag.lim.x1 - $(obj).width();
	var y1 = npjq_2drag.lim.y1 - $(obj).height();
	if(x > x1) x = x1;
	if(y > y1) y = y1;
	if(x < npjq_2drag.lim.x0) x = npjq_2drag.lim.x0;
	if(y < npjq_2drag.lim.y0) y = npjq_2drag.lim.y0;
    } else if(npjq_2drag.lim) {
	var x1 = $(npjq_2drag.lim).width() - $(obj).width();
	var y1 = $(npjq_2drag.lim).height() - $(obj).height();
	if(y1 < 0) y1 = $(window).height() - $(obj).height();
	if(x > x1) x = x1;
	if(y > y1) y = y1;
	if(x < 0) x = 0;
	if(y < 0) y = 0;
    }
    $(obj).css({ 'top': y+'px', 'left': x+'px', });
    return false;
}
function npjq_setdrag(obj, eve) {
    npjq_dropdrag();
    npjq_2drag = {'box': null, 'evex0': NaN, 'evey0': NaN, 'x0': NaN, 'y0': NaN, 'lim': null};
    npjq_2drag.box = obj;
    npjq_2drag.evex0 = eve.clientX;
    npjq_2drag.evey0 = eve.clientY;
    npjq_2drag.x0 = $(obj).position().left;
    npjq_2drag.y0 = $(obj).position().top;
    $(npjq_2drag.box).addClass('npjqmotion');
    $(window)
	.mousemove(function(e) { return npjq_drag(obj, e) })
	.mouseup(function(e) { return npjq_dropdrag() })
    ;
}
function npjq_setdragborders(x0,y0, x1,y1) {
    if(!npjq_2drag || !npjq_2drag.box) return true;
    npjq_2drag.lim = {'x0':x0, 'y0':y0, 'x1':x1, 'y1':y1};
    return false;
}
function npjq_setdraglim(box) {
    npjq_2drag.lim = box;
    return false;
}
function npjq_dropdrag() {
    if(npjq_2drag && npjq_2drag.box)
	$(npjq_2drag.box).removeClass('npjqmotion');
    npjq_2drag = null;
    $(window).off('mousemove, mouseup');
    return false;
}

$(document)
    .delegate('.npjq2move', 'mousedown', function(e) { npjq_setdrag(this, e); npjq_setdraglim(this.parentNode); return false; })
    .delegate('.npjq2move2', 'mousedown', function(e) { return npjq_setdrag(this.parentNode, e) })
;

/* -.-.- */
